defmodule AntlUtils.MixProject do
  use Mix.Project

  def project do
    [
      app: :antl_utils,
      version: "0.5.0",
      elixir: "~> 1.8",
      elixirc_paths: elixirc_paths(Mix.env()),
      start_permanent: Mix.env() == :prod,
      description: description(),
      package: package(),
      deps: deps()
    ]
  end

  defp elixirc_paths(:test), do: ["lib", "test/support"]
  defp elixirc_paths(_), do: ["lib"]

  def application do
    [
      extra_applications: [:logger]
    ]
  end

  # Run "mix help deps" to learn about dependencies.
  defp deps do
    [
      {:ex_doc, ">= 0.0.0", only: :dev, runtime: false},
      {:ecto, "~> 3.0", only: :test},
      {:absinthe_plug, "~> 1.4", only: :test}
    ]
  end

  defp description() do
    "Elixir utils."
  end

  defp package() do
    [
      licenses: ["Apache-2.0"],
      links: %{"GitHub" => "https://github.com/annatel/antl_utils"}
    ]
  end
end
